# 显示模块
![按数字进行绘制](item:tis3d:display_module)

显示模块采用一套高度灵活的方法，可将任意数据可视化为一个二维彩色单元（*编者注*：孩子们喜欢叫他们“像素”）网格。可从任意端口提供值序列来修改这些单元的颜色，其中包含要填充矩形的颜色代码、位置和大小。

显示模块持续从所有四个端口读取值，累计读取到五个值绘制一次。在一次绘制所需的五个值均被接收后，所描述的矩形会被绘制到彩色网格中。

## 绘制调用规范
显示模块收到的五个值组成的序列，依次对应绘制的各个参数：
颜色、列、行、宽度、高度
网格是由二十四（24）行和二十四（24）列组成的正方形。颜色的值由固定的颜色表决定。
确切的颜色值可能因供应方而异，但一般颜色名称遵循这个世界的规范：
- `0`：白色
- `1`：橙色
- `2`：品红色
- `3`：淡蓝色
- `4`：黄色
- `5`：黄绿色
- `6`：粉红色
- `7`：灰色
- `8`：淡灰色
- `9`：青色
- `10`：紫色
- `11`：蓝色
- `12`：棕色
- `13`：绿色
- `14`：红色
- `15`：黑色
*即MC中的基础16色*

提供非法的颜色或坐标值是未定义行为，但通常都可以被正确处理，视供应方的决策而定。

下面是一个简单的程序，可以画不同颜色的垂线：
`MOV 16 ACC`
`LOOP:`
`SUB 1`
`MOV ACC LEFT # COLOR`
`MOV ACC LEFT # X`
`MOV 0 LEFT # Y`
`MOV 1 LEFT # WIDTH`
`MOV 28 LEFT # HEIGHT`
`JNZ LOOP`
