LootJS.modifiers(event => {

  //全局箱子随机紫水晶奖励
  event.addLootTypeModifier(LootType.CHEST)
    .addLoot(LootEntry.of('minecraft:amethyst_shard')
      .when(c => c.randomChance(0.2))
      .limitCount([1, 50]));

  //全局箱子随机荧光棒奖励
  event.addLootTypeModifier(LootType.CHEST)
    .addLoot(LootEntry.of('additionaladditions:glow_stick')
      .when(c => c.randomChance(0.05))
      .limitCount([1, 10]));

  //全局箱子随机辣椒种子
  event.addLootTypeModifier(LootType.CHEST)
    .addLoot(LootEntry.of('call_of_yucutan:chili_pepper_seeds')
      .when(c => c.randomChance(0.01))
      .limitCount([3, 12]));

  //宝物箱子修改器，掉落概率=宝藏概率*箱子概率
  //宝藏物品
  const fixedLootIDs = [
    { chance: 0.01, id: 'l2complements:eternium_axe' },
    { chance: 0.01, id: 'l2complements:eternium_boots' },
    { chance: 0.01, id: 'l2complements:eternium_chestplate' },
    { chance: 0.01, id: 'l2complements:eternium_helmet' },
    { chance: 0.01, id: 'l2complements:eternium_leggings' },
    { chance: 0.01, id: 'l2complements:eternium_pickaxe' },
    { chance: 0.01, id: 'l2complements:eternium_shovel' },
    { chance: 0.01, id: 'l2complements:eternium_sword' },
    { chance: 0.3, id: 'simplyswords:contained_remnant' },
    { chance: 0.5, id: 'arcanelanterns:feral_lantern' },
    { chance: 0.5, id: 'quark:smithing_template_rune' },
    { chance: 1, id: 'additionaladditions:gilded_netherite_upgrade' },
    { chance: 1, id: 'simplyswords:runic_tablet' },
    { chance: 2, id: 'additionaladditions:rose_gold_upgrade' },
    { chance: 2, id: 'illagerinvasion:platinum_chunk' },
    { chance: 2, id: 'musketmod:musket_upgrade_smithing_template' },
    { chance: 4, id: 'minecolonies:ancienttome' },
  ];
  //宝藏箱子
  const commonLoot = [
    { chance: 0.05, lootTableId: 'quark:misc/monster_box' },//夸克怪物盒子
    { chance: 0.05, lootTableId: 'ati_structures:chests/archer_chest' },//ATI结构奖励箱子
    { chance: 0.05, lootTableId: 'ati_structures:chests/archer_chest2' },//ATI结构奖励箱子
    { chance: 0.05, lootTableId: 'ati_structures:chests/armory' },//ATI结构奖励箱子
    { chance: 0.05, lootTableId: 'ati_structures:chests/iron_storage' },//ATI结构奖励箱子
    { chance: 0.05, lootTableId: 'betterdungeons:skeleton_dungeon/chests/middle' },//YUNG骷髅地牢中间的箱子
    { chance: 0.05, lootTableId: 'betterdungeons:zombie_dungeon/chests/special' },//YUNG僵尸地牢奖励箱子
    { chance: 0.01, lootTableId: 'betterdungeons:skeleton_dungeon/chests/common' },//YUNG骷髅地牢奖励箱子
    { chance: 0.10, lootTableId: 'betterdeserttemples:chests/pot' },//Yung-沙漠神殿重制箱子
    { chance: 0.10, lootTableId: 'betterdeserttemples:chests/library' },//Yung-沙漠神殿重制箱子
    { chance: 0.15, lootTableId: 'betterdeserttemples:chests/wardrobe' },//Yung-沙漠神殿重制箱子
    { chance: 0.15, lootTableId: 'betterdeserttemples:chests/lab' },//Yung-沙漠神殿重制箱子
    { chance: 0.15, lootTableId: 'betterdeserttemples:chests/pharaoh_hidden' },//Yung-沙漠神殿重制箱子
    { chance: 0.15, lootTableId: 'betterdeserttemples:chests/storage' },//Yung-沙漠神殿重制箱子
    { chance: 0.30, lootTableId: 'betterdeserttemples:chests/tomb_pharaoh' },//Yung-沙漠神殿重制箱子
    { chance: 0.15, lootTableId: 'betterdeserttemples:chests/tomb' },//Yung-沙漠神殿重制箱子
    { chance: 0.35, lootTableId: 'dungeonnowloading:chests/labyrinth/reward' },//地牢进行时的奖励箱子
    { chance: 0.01, lootTableId: 'minecraft:chests/abandoned_mineshaft' },//废弃矿井中的运输矿车
    { chance: 0.25, lootTableId: 'minecraft:chests/bastion_treasure' },//堡垒遗迹宝藏室中的箱子
    { chance: 0.25, lootTableId: 'minecraft:chests/bastion_bridge' },
    { chance: 0.25, lootTableId: 'minecraft:chests/buried_treasure' },//埋藏的宝藏
    { chance: 0.15, lootTableId: 'minecraft:chests/desert_pyramid' },//沙漠神殿的宝藏室里的箱子
    { chance: 0.15, lootTableId: 'minecraft:chests/end_city_treasure' },//末地城里的箱子
    { chance: 0.25, lootTableId: 'minecraft:chests/jungle_temple' },//丛林神庙里的箱子
    { chance: 0.02, lootTableId: 'minecraft:chests/nether_bridge' },//下界要塞里的箱子
    { chance: 0.02, lootTableId: 'minecraft:chests/pillager_outpost' },//掠夺者前哨站的箱子
    { chance: 0.03, lootTableId: 'minecraft:chests/ruined_portal' },//废弃传送门的箱子
    { chance: 0.05, lootTableId: 'minecraft:chests/simple_dungeon' },// 地牢里的箱子
    { chance: 0.05, lootTableId: 'minecraft:chests/stronghold_corridor' },//要塞台阶祭坛里的箱子
    { chance: 0.15, lootTableId: 'minecraft:chests/stronghold_crossing' },//要塞储存室里的箱子
    { chance: 0.15, lootTableId: 'minecraft:chests/stronghold_library' },//要塞图书馆里的箱子
    { chance: 0.15, lootTableId: 'minecraft:chests/underwater_ruin_big' },//海底废墟的大型建筑物的箱子
    { chance: 0.05, lootTableId: 'minecraft:chests/underwater_ruin_small' },//海底废墟的小型建筑物的箱子
    { chance: 0.10, lootTableId: 'minecraft:chests/woodland_mansion' },//林地府邸的箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_1' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_2' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_3' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_4' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_5' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_6' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/dungeon_7' },// 地牢与酒馆地牢箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/undead_crypts_grave' },// 地牢与酒馆墓穴箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/mining_supply' },// 地牢与酒馆矿洞箱子
    { chance: 0.15, lootTableId: 'nova_structures:chests/illager_hideout_random' },// 地牢与酒馆掠夺者箱子
    { chance: 0.15, lootTableId: 'nova_structures:chests/badland_miner_outpost_forge' },
    { chance: 0.10, lootTableId: 'nova_structures:chests/badland_miner_outpost_towers' },// 地牢与酒馆掠夺者箱子
    { chance: 0.15, lootTableId: 'nova_structures:chests/pillager_outpost_treasure' },// 地牢与酒馆掠夺者箱子
    { chance: 0.15, lootTableId: 'nova_structures:chests/nether_port/nether_port_chest' },// 地牢与酒馆下界港口珍贵箱子
    { chance: 0.05, lootTableId: 'nova_structures:chests/nether_port/nether_port_supplies' },// 地牢与酒馆下界港口普通箱子
    { chance: 0.05, lootTableId: 'betterfortresses:chests/beacon' },//下界要塞重置灯塔箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/extra' },//下界要塞重置额外箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/hall' },//下界要塞重置大厅箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/keep' },//下界要塞重置城堡主楼箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/obsidian' },//下界要塞重置黑曜石箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/puzzle' },//下界要塞重置谜题箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/quarters' },//下界要塞重置主楼宿舍箱子
    { chance: 0.10, lootTableId: 'betterfortresses:chests/storage' },//下界要塞重置储藏室箱子
    { chance: 0.02, lootTableId: 'betterfortresses:chests/worship' },//下界要塞重置主楼顶楼木桶
    { chance: 0.10, lootTableId: 'incendium:reactor/junk' },//下界数据包反应炉边缘木桶
    { chance: 0.20, lootTableId: 'incendium:reactor/waste' },//下界数据包反应炉高处木桶和中央木桶
    { chance: 0.50, lootTableId: 'incendium:reactor/treasure' },//下界数据包反应炉顶部木桶
    { chance: 0.20, lootTableId: 'incendium:reactor/office' },//下界数据包反应炉办公室二楼木桶
    { chance: 0.50, lootTableId: 'incendium:reactor/office_treasure' },//下界数据包反应炉办公室岩浆下木桶
    { chance: 0.02, lootTableId: 'incendium:pipeline/junk' },//下界数据包下界管道
    { chance: 0.05, lootTableId: 'incendium:pipeline/rare' },
    { chance: 0.10, lootTableId: 'incendium:pipeline/common' },
    { chance: 0.20, lootTableId: 'incendium:pipeline/uncommon' },
    { chance: 0.50, lootTableId: 'incendium:pipeline/treasure' },
    { chance: 0.02, lootTableId: 'incendium:pipeline/base/junk' },
    { chance: 0.05, lootTableId: 'incendium:pipeline/base/rare' },
    { chance: 0.10, lootTableId: 'incendium:pipeline/base/common' },
    { chance: 0.20, lootTableId: 'incendium:pipeline/base/uncommon' },
    { chance: 0.50, lootTableId: 'incendium:pipeline/base/treasure' },
    { chance: 0.02, lootTableId: 'incendium:lab/junk' },
    { chance: 0.10, lootTableId: 'incendium:lab/rare' },
    { chance: 0.20, lootTableId: 'incendium:lab/basalt' },
    { chance: 0.50, lootTableId: 'incendium:lab/treasure' },
    { chance: 0.02, lootTableId: 'incendium:quartz_flats/junk' },
    { chance: 0.20, lootTableId: 'incendium:quartz_flats/treasure' },

    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_amethyst' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_archer' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_baking' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_books' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_excavation' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_flowers' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_iron' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_junk' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_junk_arrow' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_low_tier_treasure' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_ordinary_supply' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_painter' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_slime' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_tiny_storage' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_weapon_armor' },
    { chance: 0.10, lootTableId: 'prototypedungeons:custom/pillager_wood' },

    { chance: 0.15, lootTableId: 'call_of_yucutan:chest/crypt_chest_loot' },
    { chance: 0.15, lootTableId: 'call_of_yucutan:chest/overgrown_chest_loot' },

    { chance: 0.15, lootTableId: 'dungeons_plus:chests/tower/vex' },
    { chance: 0.10, lootTableId: 'dungeons_plus:chests/tower/common' },
    { chance: 0.08, lootTableId: 'dungeons_plus:chests/tower/barrel' },
    { chance: 0.15, lootTableId: 'dungeons_plus:chests/reanimated_ruins/common' },
    { chance: 0.15, lootTableId: 'dungeons_plus:chests/reanimated_ruins/frozen' },
    { chance: 0.15, lootTableId: 'dungeons_plus:chests/reanimated_ruins/desert' },
    { chance: 0.15, lootTableId: 'dungeons_plus:chests/reanimated_ruins/mossy' },
    { chance: 0.18, lootTableId: 'dungeons_plus:chests/snowy_temple/common' },
    { chance: 0.50, lootTableId: 'dungeons_plus:chests/snowy_temple/rare' },
    { chance: 0.18, lootTableId: 'dungeons_plus:chests/leviathan/common' },
    { chance: 0.50, lootTableId: 'dungeons_plus:chests/leviathan/rare' },
    { chance: 0.18, lootTableId: 'dungeons_plus:chests/warped_garden/common' },
    { chance: 0.50, lootTableId: 'dungeons_plus:chests/warped_garden/rare' },
    { chance: 0.18, lootTableId: 'dungeons_plus:chests/soul_prison/common' },
    { chance: 0.50, lootTableId: 'dungeons_plus:chests/soul_prison/rare' },

    { chance: 0.15, lootTableId: 'hopo:chests/copper' },
    { chance: 0.15, lootTableId: 'hopo:chests/coral' },
    { chance: 0.15, lootTableId: 'hopo:chests/materials' },
    { chance: 0.15, lootTableId: 'hopo:chests/prismarine' },
    { chance: 0.15, lootTableId: 'hopo:chests/small_ruin_cold' },
    { chance: 0.15, lootTableId: 'hopo:chests/small_ruin_warm' },

    { chance: 0.20, lootTableId: 'alexscaves:chests/abyssal_ruins' },
    { chance: 0.20, lootTableId: 'alexscaves:chests/caveman_house' },
    { chance: 0.20, lootTableId: 'alexscaves:chests/forlorn_ruins' },
    { chance: 0.20, lootTableId: 'alexscaves:chests/gingerbread_town' },
    { chance: 0.10, lootTableId: 'alexscaves:chests/licowitch_tower' },
    { chance: 0.30, lootTableId: 'alexscaves:chests/licowitch_tower_secret' },
    { chance: 0.20, lootTableId: 'alexscaves:chests/magnetic_ruins' },
    { chance: 0.20, lootTableId: 'alexscaves:chests/toxic_ruins' },

  ];
  commonLoot.forEach(entry => {
    event
      .addLootTableModifier(entry.lootTableId)
      .pool(global.treasureItemsPoll(entry.chance))
  })

  function addLootToMultipleStructures(lootTableEntries, loots) {
    lootTableEntries.forEach(entry => {
      loots.forEach(loot => {
        const finalChance = entry.chance * loot.chance;
        event.addLootTableModifier(entry.lootTableId)
          .apply(ctx => {
            const adjustedFinalChance = Math.min(finalChance, 1);
            ctx.addLoot(LootEntry.of(loot.id)
              .when((c) => c.randomChance(adjustedFinalChance)));
          });
      });
    });
  }
  addLootToMultipleStructures(commonLoot, fixedLootIDs);
});