//tp时传送跟随的士兵
ForgeEvents.onEvent("net.minecraftforge.event.entity.EntityTeleportEvent", event => {
    global.EntityTeleportEvent(event)
})
/**
 * 
 * @param {Internal.EntityTeleportEvent} event 
 */
global.EntityTeleportEvent = event => {
    if (event.entity.type == 'minecraft:player') {
        let player = event.entity;
        // 当玩家处于临时传送状态时跳过处理
        if (player.tags.contains('temp_tp')) {
            player.removeTag('temp_tp');
            return;
        }
        // 存储传送数据到持久化数据
        let data = player.persistentData;
        data.putDouble("snk_tp_x", event.targetX);
        data.putDouble("snk_tp_y", event.targetY);
        data.putDouble("snk_tp_z", event.targetZ);
        data.putFloat("snk_tp_yaw", player.yaw);
        data.putFloat("snk_tp_pitch", player.pitch);
        data.putString("snk_tp_dim", player.level.dimension.path);
        player.addTag('temp_tp');
        let uuid = player.uuid;
        // 传送士兵逻辑
        player.server.runCommandSilent(`execute as ${uuid} run scoreboard players operation TP snk_newid = @s snk_newid`);
        player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_troop_mount] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
        player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_follow] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
        // 延迟传送玩家
        player.server.scheduleInTicks(5, () => {
            player.teleportTo(
                data.getString("snk_tp_dim"),
                data.getDouble("snk_tp_x"),
                data.getDouble("snk_tp_y"),
                data.getDouble("snk_tp_z"),
                data.getFloat("snk_tp_yaw"),
                data.getFloat("snk_tp_pitch")
            );
        });
        event.setCanceled(true);
    }
};
//使用指路石时传送跟随的士兵
ForgeEvents.onEvent("net.blay09.mods.waystones.api.WaystoneTeleportEvent$Pre", event => {
    global.WaystoneTeleportEvent(event)
});

/**
 * 
 * @param {Internal.WaystoneTeleportEvent$Pre} event 
 */
global.WaystoneTeleportEvent = event => {
    let player = event.context.entity
    // 存储传送数据到持久化数据
    let data = player.persistentData
    data.putDouble("snk_tp_x", event.destination.location.get('x'));
    data.putDouble("snk_tp_y", event.destination.location.get('y'));
    data.putDouble("snk_tp_z", event.destination.location.get('z'));
    data.putFloat("snk_tp_yaw", player.yaw);
    data.putFloat("snk_tp_pitch", player.pitch);
    data.putString("snk_tp_dim", player.level.dimension.path);
    player.addTag('temp_tp');
    let uuid = player.uuid
    // 传送士兵逻辑
    player.server.runCommandSilent(`execute as ${uuid} run scoreboard players operation TP snk_newid = @s snk_newid`);
    player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_troop_mount] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
    player.server.runCommandSilent(`execute in ${data.getString("snk_tp_dim")} as @e[tag=snk_follow] if score @s snk_newid = TP snk_newid run tp ${data.getDouble("snk_tp_x")} ${data.getDouble("snk_tp_y")} ${data.getDouble("snk_tp_z")}`);
    // 延迟传送玩家
    player.server.scheduleInTicks(5, () => {
        player.teleportTo(
            data.getString("snk_tp_dim"),
            data.getDouble("snk_tp_x"),
            data.getDouble("snk_tp_y"),
            data.getDouble("snk_tp_z"),
            data.getFloat("snk_tp_yaw"),
            data.getFloat("snk_tp_pitch")
        );
    });
    event.setCanceled(true);
}
//跨越维度时传送跟随的士兵
ForgeEvents.onEvent("net.minecraftforge.event.entity.EntityTravelToDimensionEvent", event => {
    global.EntityTravelToDimensionEvent(event)
})
/**
 * 
 * @param {Internal.EntityTravelToDimensionEvent} event 
 */
global.EntityTravelToDimensionEvent = event => {
    if (event.entity.type == 'minecraft:player') {
        let player = event.entity.uuid
        event.entity.server.runCommandSilent(`execute as ${player} run scoreboard players operation TP snk_newid = @s snk_newid`)
        event.entity.server.runCommandSilent(`execute as @e[tag=snk_troop_mount] if score @s snk_newid = TP snk_newid run tp @s ${player}`)
        event.entity.server.runCommandSilent(`execute as @e[tag=snk_follow] if score @s snk_newid = TP snk_newid run tp @s ${player}`)
    }
}
